<template>
  <div class="page-container list-container">
    <!-- 功能按钮区 -->
    <div class="list-btns-container">
      <el-dropdown trigger="click">
        <el-button type="primary" size="small">
          其它<el-icon class="el-icon--right"><arrow-down /></el-icon>
        </el-button>
        <template #dropdown>
          <el-dropdown-menu>
            <el-dropdown-item icon="Download" @click="handleExport" v-hasPermi="['business:deposit:export']">
              导出</el-dropdown-item>
          </el-dropdown-menu>
        </template>
      </el-dropdown>
    </div>
    <!-- 搜索区 -->
    <el-form class="list-search-container" :model="queryParams" ref="queryRef" :inline="true" label-width="68px">
      <el-form-item label="客户名称：" prop="companyName">
        <el-input v-model="queryParams.companyName" size="small" style="width: 130px" placeholder="请输入客户名称" clearable
          @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="所属月：">
        <el-date-picker v-model="currentMonth" size="small" type="month" style="width: 130px" format="YYYY年MM月"
          :clearable="false" value-format="YYYY-MM-01" @change="currentMonthChange"
          :disabled-date="disabledDateHandler" />
      </el-form-item>
      <el-form-item label="状态：">
        <el-select v-model.trim="queryParams.status" prop="status" size="small" type="text" placeholder="状态"
          :clearable="true" style="width: 130px" @clear="clearStatus">
          <el-option v-for="item in selectStatus" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="审核人：" prop="verifierName">
        <el-input size="small" v-model="queryParams.verifierName" placeholder="请输入审核人" clearable style="width: 130px"
          @keyup.enter="handleQuery" />
      </el-form-item>

      <el-form-item prop="dateFilter" label="审核时间：">
        <el-date-picker size="small" v-model="queryParams.dateFilter" type="daterange" clearable
          format="YYYY - MM - DD " value-format="YYYY-MM-DD" range-separator="至" start-placeholder="业务日期"
          end-placeholder="业务日期" style="width: 70%;"></el-date-picker>
      </el-form-item>
      <!-- <el-form-item v-if="tenant.versionId !== '4'" label="是否自己负责:" v-hasPermi="['business:declare:person']">
        <el-switch v-model="oneself" @change="handleOneself" />
      </el-form-item> -->
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery" size="small">搜索</el-button>
        <el-button icon="operation" @click="moreSearch = true" size="small">更多</el-button>
        <el-button icon="Refresh" @click="resetQuery" size="small">重置</el-button>
      </el-form-item>
    </el-form>
    <div v-if="flag && flag2 && tenant.versionId !== '4'">
      <el-tabs v-model="activeName" class="demo-tabs" @tab-click="handleClick">
        <el-tab-pane label="全部" name="first">
        </el-tab-pane>
        <el-tab-pane label="我的" name="second">
        </el-tab-pane>
      </el-tabs>
    </div>
    <!-- 列表区 -->
    <el-table v-loading="loading" :data="orderList" size="small" border height="100%"
      @selection-change="handleSelectionChange">
      <!-- <el-table-column type="selection" width="55" align="center" /> -->
      <el-table-column label="客户名称" min-width="250" align="center" prop="companyName" />
      <el-table-column label="来源" align="center" prop="fromCompanyName" v-if="tenant.versionId === '4'" />
      <el-table-column label="受委托方" align="center" prop="toTenantName" min-width="130"
        v-if="tenant.versionId !== '4'" />
      <el-table-column label="纳税性质" min-width="100" align="center" prop="taxType" />
      <el-table-column label="人员信息" min-width="60" align="center" prop="">
        <template #default="scope">
          <el-button v-hasPermi="['business:socialSecurityDeclare:query']" v-if="scope.row.detail != null" link
            type="primary" size="small" @click="showMember(scope.row)">查看</el-button>
        </template>
      </el-table-column>
      <el-table-column label="申报填写" width="100" align="center" prop="">
        <template #default="scope">
          <el-button link type="primary" size="small" @click="fillIn(scope.row)">{{
            scope.row.detail == null
            ? "填写"
            : scope.row.detail.status === 1
            ? "进行中"
            : "已填写"
            }}</el-button>
        </template>
      </el-table-column>
      <el-table-column label="申报附件" width="100" align="center" prop="">
        <template #default="scope">
          <el-button v-hasPermi="[
              'business:socialSecurityDeclare:edit',
              'business:socialSecurityDeclare:view',
              'business:socialSecurityDeclare:verify',
            ]" size="small" type="primary" link :disabled="scope.row.detail == null || scope.row.detail.status <= 1"
            @click="showFiles(scope.row)">查看文件</el-button>
        </template>
      </el-table-column>
      <el-table-column label="状态" width="110" align="center" prop="">
        <template #default="scope">
          <div :style="getStatusStyle(scope.row)">
            {{ getStatusLabel(scope.row) }}
            <el-popover placement="top-start" width="250" trigger="hover">
              <div style="display: flex; flex-direction: row">
                <div v-for="item in selectStatus" :key="item.value"
                  style="display: flex; flex-direction: row; margin-right: 10px">
                  <div :style="{
                      backgroundColor: item.color,
                      width: '14px',
                      height: '14px',
                      margin: 'auto',
                      borderRadius: '50%',
                      border: item.color === '#fff' ? '1px solid #ddd' : 'none',
                    }" />
                  <div style="
                      display: inline-block;
                      margin-left: 10px;
                      line-height: 36px;
                      font-size: 10px;
                    ">
                    {{ item.label }}
                  </div>
                </div>
              </div>
              <template #reference>
                <span style="
                    color: #fff;
                    font-size: 12px;
                    text-align: center;
                    display: inline-block;
                    line-height: 14px;
                    width: 14px;
                    height: 14px;
                    background-color: #ccc;
                    border-radius: 50%;
                  ">?</span>
              </template>
            </el-popover>
          </div>
        </template>
      </el-table-column>
      <el-table-column label="执行人" width="80" align="center" prop="serviceName" />
      <el-table-column label="审核人" align="center" prop="verifierName" min-width="100" />
      <el-table-column label="审核时间" align="center" prop="verifierTime" min-width="100" :show-overflow-tooltip="true" />

      <!-- <el-table-column label="操作" width="80" align="center" prop="">
        <template #default="scope">
          <el-button v-hasPermi="['business:socialSecurityDeclare:edit']" size="small" type="primary" link :disabled="
              scope.row.detail == null || scope.row.detail.status !== 3
            " @click="turnBack(scope.row.detail)">退回</el-button>
        </template>
      </el-table-column> -->
    </el-table>
    <!-- 分页 -->
    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize" @pagination="getList" />
    <form-dialog ref="formDialogRef" :get-list="getList" />
    <view-dialog ref="viewDialogRef" :get-list="getList" />
    <member-dialog ref="memeberDialogRef" :get-list="getList" />
    <FileListDialog ref="fileListDialogRef" :get-list="getList" />
    <!-- 更多搜索弹窗 -->
    <el-dialog title="更多搜索" v-model="moreSearch" width="620px" append-to-body size="small" draggable
      :close-on-click-modal="false">
      <el-form :model="queryParams" ref="queryRef" size="small" label-width="100">
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="客户名称：" prop="companyName">
              <el-input v-model="queryParams.companyName" placeholder="请输入客户名称" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="纳税性质：" prop="taxType">
              <el-select size="small" v-model="queryParams.taxType" placeholder="请选择纳税性质" :clearable="true"
                @change="taxTypeChange">
                <el-option v-for="item in taxTypes" :key="item.label" :label="item.label" :value="item.value" />
              </el-select>
            </el-form-item>
            <el-form-item v-if="tenant.versionId === '4'" label="来源：" prop="fromCompanyName">
              <el-input size="small" v-model="queryParams.fromCompanyName" type="text" placeholder="客户来源"
                :clearable="true" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="状态：">
              <el-select v-model.trim="queryParams.status" prop="status" size="small" type="text" placeholder="状态"
                :clearable="true" @clear="clearStatus">
                <el-option v-for="item in selectStatus" :key="item.value" :label="item.label" :value="item.value" />
              </el-select>
            </el-form-item>
            <el-form-item label="所属月：">
              <el-date-picker v-model="currentMonth" type="month" format="YYYY年MM月" :clearable="false"
                value-format="YYYY-MM-01" @change="currentMonthChange" :disabled-date="disabledDateHandler" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" icon="Finished" size="small" @click="handleQuery">确 定</el-button>
          <el-button icon="close" size="small" @click="moreSearch = false">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="SocialSecurityDeclare">
  import useUserStore from "@/store/modules/user";
  import {
    listSocialSecurityDeclare,
    turnBackDetail,
    exportSocialSecurityDeclare,
  } from "@/api/business/production/socialSecurityDeclare";
  import { uploadFile } from "@/api/tool/file";
  import { listCompany } from "@/api/business/crm/company";
  import { ref } from "vue";
  import formDialog from "./form";
  import viewDialog from "./view";
  import { taxTypes } from "@/utils/default";
  import memberDialog from "../memberDialog";
  import FileListDialog from "../fileListDialog.vue";
  const { proxy } = getCurrentInstance();
  /** 字典数组区 */
  /** 查询 对象 */
  const tenant = useUserStore().tenant;
  const orderList = ref([]);
  const loading = ref(true);
  const oneself = ref(false);
  const ids = ref([]);
  const single = ref(true);
  const moreSearch = ref(false);
  const multiple = ref(true);
  const total = ref(0);
  const prev = ref([]);
  const baseUrl = ref(import.meta.env.VITE_APP_BASE_API);
  const showViewer = ref(false);
  const currentFileList = ref([]);
  const showIndex = ref(0);
  const formDialogRef = ref(null);
  const viewDialogRef = ref(null);
  const memeberDialogRef = ref(null);
  const fileListDialogRef = ref(null);

  const formOpen = ref(false);
  const currentMonth = ref(proxy.moment().format("YYYY-MM-01"));
  const flag = ref(checkPermission(['business:declare:person']))
  const flag2 = ref(checkPermission(['business:declare:myself']))
  const activeName = flag.value ? ref('first') : ref('second');
  const form = ref({
    id: null,
    companyName: "",
    companyId: null,
    remark: "",
    type: 1,
    files: [],
  });

  const emptyForm = {
    id: null,
    companyName: "",
    companyId: null,

    type: 1,
    remark: "",
    files: [],
  };

  const permissions = useUserStore().permissions;
  const all_permission = "*:*:*";

  const data = reactive({
    selectStatus: [
      {
        label: "未开始",
        value: 0,
        color: "#888",
      },
      {
        label: "进行中",
        value: 1,
        color: "#FFB836",
      },
      {
        label: "已完成",
        value: 3,
        color: "#2FCB81",
      },
    ],
  });
  const { selectStatus, selectMonths } = toRefs(data);

  const { verify_status } = proxy.useDict("verify_status");
  /** 查询对象 */
  const queryParams = ref({
    pageNum: 1,
    pageSize: 20,
    companyName: "",
    orderByColumn: "create_time",
    year: proxy.moment().format("YYYY"),
    month: proxy.moment().format("MM"),
    principal: tenant.versionId !== '4' && !flag.value ? useUserStore().user.userId : null,
  });

  /***********************  方法区  ****************************/
  onActivated(() => {
    // 你的逻辑
    getList();
  });
  /** 查询company列表 */
  function getList() {
    loading.value = true;
    listSocialSecurityDeclare(queryParams.value).then((response) => {
      orderList.value = response.rows.map((l) => ({ ...l }));
      prev.value = proxy.deepClone(response.rows);
      total.value = response.total;
      loading.value = false;
    });
  }

  /** 搜索按钮操作 */
  function handleQuery() {
    queryParams.value.pageNum = 1;
    moreSearch.value = false;
    getList();
  }
  function checkPermission(templatePermission) {
    const all_permission = "*:*:*";
    const permissions = useUserStore().permissions;
    const hasPermissions = permissions.some((permission) => {
      return (
        all_permission === permission || templatePermission.includes(permission)
      );
    });
    return hasPermissions;
  }
  function handleClick(tab) {
    console.log(tab.props.name)
    if (tab.props.name === "second") {
      oneself.value = true
      handleOneself()
    } else {
      oneself.value = false
      handleOneself()
    }
  }
  /** 重置按钮操作 */
  function resetQuery() {
    queryParams.value = {
      pageNum: 1,
      pageSize: 10,
      companyName: "",
      orderByColumn: "create_time",
      year: proxy.moment().format("YYYY"),
      month: proxy.moment().format("MM"),
    };
    if (activeName.value != null && activeName.value === 'second') {
      queryParams.value.principal = useUserStore().user.userId;
    }
    handleQuery();
  }

  /** 是否为自己负责 */
  function handleOneself() {
    if (oneself.value) {
      queryParams.value.principal = useUserStore().user.userId;
    } else {
      queryParams.value.principal = null;
    }
    getList();
  }

  // 多选框选中数据
  function handleSelectionChange(selection) {
    ids.value = selection.map((item) => item.id);
    single.value = selection.length != 1;
    multiple.value = !selection.length;
  }

  /** 导出按钮操作 */
  function handleExport() {
    exportSocialSecurityDeclare(queryParams.value);
  }

  function openFollowFile(arg) {
    // console.log(arg)
    const attach = arg;
    window.open(`${arg.url}`, arg.fileName);
  }

  function showFileList(row) {
    currentFileList.value = row.files.map((l) => `${baseUrl.value}${l.fileUrl}`);
    showViewer.value = true;
  }

  function closeImages() {
    showViewer.value = false;
  }

  function showMember(row) {
    memeberDialogRef.value.open({
      companyId: row.companyId,
      year: queryParams.value.year,
      month: queryParams.value.month,
    });
  }

  function fillIn(row) {
    // 判断选中行的状态
    if (row.detail != null) {
      const detail = row.detail;
      directDialog(detail);
    } else {
      const detail = {
        socialSecurityDeclareId: row.id,
        companyId: row.companyId,
        companyName: row.companyName,
        month: queryParams.value.month,
        year: queryParams.value.year,
      };
      directDialog(detail);
    }
  }

  function directDialog(detail) {
    if (detail.status === 0 || detail.status == null) {
      if (editable()) {
        formDialogRef.value.open(detail);
      } else {
        proxy.$modal.msgError("没有权限");
      }
    } else if (detail.status === 1 || detail.status === 4) {
      if (editable()) {
        formDialogRef.value.open(detail);
      } else if (viewable() || verifiable()) {
        viewDialogRef.value.open(detail);
      } else {
        proxy.$modal.msgError("没有权限");
      }
    } else if (detail.status === 2 || detail.status === 3) {
      if (editable() || viewable() || verifiable()) {
        viewDialogRef.value.open(detail);
      } else {
        proxy.$modal.msgError("没有权限");
      }
    }
  }

  function viewable() {
    return (
      permissions.includes(all_permission) ||
      permissions.includes("business:socialSecurityDeclare:view")
    );
  }

  function editable() {
    return (
      permissions.includes(all_permission) ||
      permissions.includes("business:socialSecurityDeclare:edit")
    );
  }

  function verifiable() {
    return (
      permissions.includes(all_permission) ||
      permissions.includes("business:socialSecurityDeclare:verify")
    );
  }

  function showFiles(row) {
    fileListDialogRef.value.open(row.detail);
  }

  function getStatusStyle(row) {
    if (row.detail == null) {
      return { color: getStatusColor(0), verticalAlign: "middle" };
    } else {
      return {
        color: getStatusColor(row.detail.status),
        verticalAlign: "middle",
      };
    }
  }
  function getStatusColor(status) {
    const index = selectStatus.value.findIndex((v) => v.value === status);
    return index >= 0 ? selectStatus.value[index].color : "#fff";
  }
  function getStatusLabel(row) {
    const index = selectStatus.value.findIndex(
      (v) => v.value === (row.detail == null ? 0 : row.detail.status)
    );
    return index >= 0 ? selectStatus.value[index].label : "";
  }

  function turnBack(detail) {
    turnBackDetail(detail)
      .then((res) => {
        getList();
      })
      .catch((err) => {
        proxy.$modal.msgError(err.message);
      });
  }

  function currentMonthChange(arg) {
    const year = proxy.moment(arg).format("YYYY");
    const month = proxy.moment(arg).format("MM");
    queryParams.value.year = year;
    queryParams.value.month = month;
    handleQuery();
  }

  function clearStatus() {
    queryParams.value.status = null;
  }

  function disabledDateHandler(date) {
    if (date <= proxy.moment()) {
      return false;
    } else {
      return true;
    }
  }

  getList();
</script>